/*
 *
 * Author:   (, 3, ..:80527)
 *
 *  ( 10)
 *  3 ()
 */

#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include "stack.h"

typedef int(*operPtr) (int, int);

int sum(int, int);
int sub(int, int);
int mul(int, int);
int division(int, int);
operPtr getOperation(char c);

Stack buffer;
int error = 0; // Error counter

int main() {
	int a, b;
	char input;
	operPtr p;

	while((input = getchar()) != '\n' && error == 0) {
		if(isdigit(input))
			push(&buffer, input-'0');
		else {
			p = getOperation(input);
			if(p == NULL)
				error++;
			else {
				if(pop(&buffer, &b) && pop(&buffer, &a))
					push(&buffer, p((int)a, (int)b));
			}
		}
	}

	if(error != 0)
		printf("ERROR\n");
	else
		while(!isEmpty(&buffer)) {
			int result;
			pop(&buffer, &result);
			printf("%d\n", result);
		}

	system("pause");
	return 0;
}

operPtr getOperation(char c) {
	switch(c) {
		case '+':
			return sum;
		case '-':
			return sub;
		case '*':
			return mul;
		case '/':
			return division;
		default:
			return NULL;
	}
}

int sum(int a, int b) {
	return a+b;
}

int sub(int a, int b) {
	return a-b;
}

int mul(int a, int b) {
	return a*b;
}

int division(int a, int b) {
	if(b == 0) {
		error++;
		return 0;
	}
	return a/b;
}